/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * e:/builds/moz2_slave/mozilla-central-win32-xulrunner/build/content/base/public/nsIFrameLoader.idl
 */

package org.mozilla.interfaces;

public interface nsIFrameLoader extends nsISupports {

  String NS_IFRAMELOADER_IID =
    "{65d2c9e2-852c-48cf-a95d-9b82f1273c15}";

  /**
   * Get the docshell from the frame loader.
   */
  nsIDocShell getDocShell();

  /**
   * Get the nsIWebProgress from the frame loader, allowing listener registration.
   */
  nsIWebProgress getWebProgress();

  /**
   * Start loading the frame. This method figures out what to load
   * from the owner content in the frame loader.
   */
  void loadFrame();

  /**
   * Loads the specified URI in this frame. Behaves identically to loadFrame,
   * except that this method allows specifying the URI to load.
   */
  void loadURI(nsIURI aURI);

  /**
   * Destroy the frame loader and everything inside it. This will
   * clear the weak owner content reference.
   */
  void destroy();

  /**
   * Find out whether the loader's frame is at too great a depth in
   * the frame tree.  This can be used to decide what operations may
   * or may not be allowed on the loader's docshell.
   */
  boolean getDepthTooGreat();

  /**
   * Activate remote frame.
   * Throws an exception with non-remote frames.
   */
  void activateRemoteFrame();

  /**
   * @see nsIDOMWindowUtils sendMouseEvent.
   */
  void sendCrossProcessMouseEvent(String aType, float aX, float aY, int aButton, int aClickCount, int aModifiers, boolean aIgnoreRootScrollFrame);

  /**
   * Activate event forwarding from client (remote frame) to parent.
   */
  void activateFrameEvent(String aType, boolean capture);

  nsIChromeFrameMessageManager getMessageManager();

  /**
   * @see nsIDOMWindowUtils sendKeyEvent.
   */
  void sendCrossProcessKeyEvent(String aType, int aKeyCode, int aCharCode, int aModifiers, boolean aPreventDefault);

  boolean getDelayRemoteDialogs();

  void setDelayRemoteDialogs(boolean aDelayRemoteDialogs);

}